// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "SocketServer.h"
#include "SocketServerBPLibrary.h"
#include "ServerPluginActor.generated.h"

UCLASS()
class SERVERPLUGINCODEDEMO_API AServerPluginActor : public AActor
{
	GENERATED_BODY()
	
public:	
	// Sets default values for this actor's properties
	AServerPluginActor();

	FString serverIDGlobal = FString();
	USocketServerBPLibrary* socketServerLib = nullptr;

	UFUNCTION()
		void socketServerConnectionEventDelegate(const EServerSocketConnectionEventType type, const bool success, const FString message, const FString sessionID, const FString serverID);
	UFUNCTION()
		void serverReceiveTCPMessageEventDelegate(const FString sessionID, const FString message, const TArray<uint8>& byteArray, const FString serverID);


protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

	virtual void EndPlay(const EEndPlayReason::Type EndPlayReason) override;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

};
